#!/usr/bin/perl -w
#*******************************************************************************
# Copyright (c) 2005, 2006 IBM Corporation and others.
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v1.0
# which accompanies this distribution, and is available at
# http://www.eclipse.org/legal/epl-v10.html
#
# Contributors:
# IBM Corporation - initial API and implementation
#*******************************************************************************

use Cwd qw(abs_path);
use File::Basename qw(dirname);

$port = "8050";
$helpFlag = "-h";
$dir = dirname(abs_path($0));
#$javaExe = dirname($dir) . "/ibm-java-70-64bit/jre/bin/java";
$javaExe= dirname($dir) . "/ibm-java-71-64bit/jre/bin/java";

if (! -e $javaExe)
{
 # $javaExe = "java";
 die "Did not find required IBM Java7 64-bit JRE at " . $javaExe . "\n";
}
if (defined($ARGV[0]))
{	
	$port = $ARGV[0];
}


$isHelp = $helpFlag cmp $port;
if ($isHelp == 0)
{
   print("command usage:\n");
   print("daemon.pl [<port> | <low port>-<high port>] [ <low server port>-<high server port>]\n");
 0;
}
else
{
	$user=`whoami`; chomp($user);
	$match = $user cmp "root";

	if ($match != 0)
	{
	    print("WARNING: To run the server daemon, you must have root authority\n");
	}

	    $plugins_dir=$dir;
		
	    $ENV{A_PLUGIN_PATH}="$plugins_dir/";
	    $oldClasspath = $ENV{CLASSPATH};
		$ENV{CLASSPATH}="$plugins_dir:$plugins_dir/dstore_extra_server.jar:$plugins_dir/dstore_core.jar:$plugins_dir/dstore_miners.jar:$plugins_dir/clientserver.jar:$plugins_dir/cdtminer.jar:$plugins_dir/cdtmodel.jar:$plugins_dir/cdtparser.jar:$plugins_dir/lrparser.jar:$plugins_dir/xlcparser.jar:$plugins_dir/net.sourceforge.lpg.lpgjavaruntime_1.1.0.v201004271650.jar:$plugins_dir/org.eclipse.core.runtime_3.8.0.v20120521-2346.jar:$plugins_dir/org.eclipse.equinox.common_3.6.100.v20120522-1841.jar:$plugins_dir/org.eclipse.core.filesystem_1.3.200.v20120522-2012.jar:$plugins_dir/com.ibm.icu_4.4.2.v20110823.jar:$plugins_dir/org.eclipse.text_3.5.200.v20120523-1310.jar:$plugins_dir/stubs.jar:$plugins_dir/com.ibm.etools.minerhelpers.jazz.jar:$plugins_dir/com.ibm.etools.minerhelpers.pushpull.jar:$plugins_dir/spawner.jar:$plugins_dir/offlineIndexer.jar:$plugins_dir/mctminer.jar:$plugins_dir/org.eclipse.jgit_1.2.0.201112221803-r.jar:$plugins_dir/com.jcraft.jsch_0.1.41.v200903070017.jar:$plugins_dir/RDpAnalysisMiner.jar:$plugins_dir/RSAZHelper.jar:$plugins_dir/RDpGeneralRules.jar:$plugins_dir/RDpMigrationRules.jar:$plugins_dir/executeminer.jar:$plugins_dir/CDTDerivativeMiner.jar";
		if (defined ($oldClasspath))
		{
		  $ENV{CLASSPATH}="$ENV{CLASSPATH}:$oldClasspath";
		}

		if (defined($ARGV[1]))
		{
			exec("$javaExe -Xms64m -Xmx128m -Xss2m -DA_PLUGIN_PATH=\$A_PLUGIN_PATH org.eclipse.dstore.core.server.ServerLauncher $port $ARGV[1]");
		}
		else
		{
		    exec("$javaExe -Xms64m -Xmx128m -Xss2m -DA_PLUGIN_PATH=\$A_PLUGIN_PATH org.eclipse.dstore.core.server.ServerLauncher $port");
		}

}
